#include <stdio.h>
#include "newton.h"

int main(int argc, char* argv[])
{
	NewtonWorld* world = NewtonCreate (NULL, NULL);

	NewtonCollision* collision = NewtonCreateSphere (world, 1.0f, 1.0f, 1.0f, NULL); 
	NewtonBody* sphere = NewtonCreateBody (world, collision);
	NewtonReleaseCollision (world, collision);
	NewtonBodySetMassMatrix (sphere, 1.0f, 1.0f, 1.0f, 1.0f);
	dFloat sphereMatrix[16] = {1,0,0,0, 0,1,0,0, 0,0,1,0, 5,6,7,1};
	NewtonBodySetMatrix(sphere, sphereMatrix);
	NewtonBodySetLinearDamping(sphere, 0.0f);

	collision = NewtonCreateBox (world, 100.0f, 100.0f, 1.0f, NULL);
	NewtonBody* block = NewtonCreateBody (world, collision);
	NewtonReleaseCollision (world, collision);
	NewtonBodySetMassMatrix (block, 1000.0f, 1000.0f, 1000.0f, 1000.0f);
	dFloat blockMatrix[16] = {1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1};
	NewtonBodySetMatrix(block, blockMatrix);
	NewtonBodySetLinearDamping(block, 0.0f);

	dFloat v[3] = {0,0,-1};
	NewtonBodySetVelocity(sphere, v);

	for(int i = 0; i < 500; i++)
	{
		NewtonUpdate(world, 0.05f);
		NewtonBodyGetMatrix(sphere, sphereMatrix);
		NewtonBodyGetMatrix(block, blockMatrix);
		printf("%f %f %f   %f %f %f\n", sphereMatrix[12], sphereMatrix[13], sphereMatrix[14], blockMatrix[12], blockMatrix[13], blockMatrix[14]);
	}

	NewtonDestroyBody(world, sphere);
	NewtonDestroyBody(world, block);
	NewtonDestroy(world);

	int dummy = getchar();

	return 0;
}

